// Generated by CoffeeScript 2.3.1
(function() {
  var debug, foot, pkg;

  pkg = require('../../../package');

  this.name = `${pkg.name}:middleware:client:egress:fifo`;

  ({debug, foot} = (require('tangible'))(this.name));

  this.include = async function() {
    var ACTION_CONF_ROUTE, ACTION_EAVESDROP, ACTION_FIFO_ROUTE, ACTION_FIFO_VOICEMAIL, ACTION_INTERCEPT, ACTION_MENU_ROUTE, ACTION_MONITOR, ACTION_MSG_ACTIVATE, ACTION_MSG_DEACTIVATE, ACTION_MSG_LISTEN, ACTION_MSG_RECORD, ACTION_QUEUER_LEAVE, ACTION_QUEUER_LOGIN, ACTION_QUEUER_LOGIN_SCRIPT, ACTION_QUEUER_LOGOUT, ACTION_QUEUER_OFFHOOK, action, agent, agent_data, agent_name, agent_tags, allowed_groups, base, base1, base2, base3, base4, doc, events, failed, fifo, file, get, groups, is_allowed, key, m, number, number_data, ref, ref1, ref2, ref3, ref4, route, spy, uri, uuid;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'centrex') {
      return;
    }
    if (this.session.forwarding === true) {
      return;
    }
    if (!this.session.number_domain) {
      debug('No number domain');
      return;
    }
    if (!(m = this.destination.match(/^(80\d\d|81\d|82|83|84|87|88)(\d*)$/))) {
      return;
    }
    action = m[1];
    if (m[2] === '') {
      number = null;
    } else {
      number = parseInt(m[2], 10);
      key = `${number}@${this.session.number_domain}`;
      // * doc.local_number:groups (array of string) Contains groups the user belong too. The convention is to use `:` as a separator. For example: ['sales:internal','support:modems']
      ({groups} = number_data = (await this.cfg.prov.get(`number:${key}`).catch(function() {
        return {};
      })));
    }
    events = (ref1 = this.cfg.queuer) != null ? (ref2 = ref1.Agent) != null ? ref2.events : void 0 : void 0;
    spy = async(monitor) => {
      var agent, agent_is_aleg, agent_is_bleg, call, eavesdrop, no_whisper, uuid;
      if (!events) {
        debug.dev('No `events`, cannot spy');
        this.action('hangup');
        return;
      }
      // Which is a-leg or b-leg still needs to be confirmed, I have some suspicion this is wrong for some scenarios.
      agent_is_aleg = async() => {
        return (await this.set({
          eavesdrop_bridge_aleg: true,
          eavesdrop_bridge_bleg: true,
          eavesdrop_whisper_aleg: monitor,
          eavesdrop_whisper_bleg: false
        }));
      };
      agent_is_bleg = async() => {
        return (await this.set({
          eavesdrop_bridge_aleg: true,
          eavesdrop_bridge_bleg: true,
          eavesdrop_whisper_aleg: false,
          eavesdrop_whisper_bleg: monitor
        }));
      };
      no_whisper = async() => {
        return (await this.set({
          eavesdrop_bridge_aleg: true,
          eavesdrop_bridge_bleg: true,
          eavesdrop_whisper_aleg: false,
          eavesdrop_whisper_bleg: false
        }));
      };
      eavesdrop = async(uuid, notify) => {
        if (notify && monitor) {
          await this.cfg.api(`uuid_broadcast ${uuid} gentones::%(125,0,450)`);
        }
        return (await this.action('eavesdrop', uuid));
      };
      // `call` is the agent's on-hook call
      events.on([key, 'onhook', 'bridge'], foot(async(call) => {
        var uuid;
        uuid = (await call.get_id());
        await agent_is_aleg();
        return (await eavesdrop(uuid, true));
      }));
      // `call` is the agent's off-hook call
      events.on([key, 'offhook', 'bridge'], foot(async(call) => {
        var uuid;
        uuid = (await call.get_id());
        await agent_is_aleg();
        return (await eavesdrop(uuid, true));
      }));
      // `call` is the agent's remote-call
      events.on([key, 'remote', 'bridge'], foot(async(call, disposition, our_call) => {
        var uuid;
        uuid = (await our_call.get_id());
        await agent_is_bleg();
        // uuid = await call.get_id()
        // await no_whisper()
        return (await eavesdrop(uuid, true));
      }));
      // `call` is another (outside-of-call-center) call
      events.on([key, 'external', 'bridge'], foot(async(call, disposition, our_call) => {
        var uuid;
        uuid = (await our_call.get_id());
        await agent_is_bleg();
        // uuid = await call.get_id()
        // await no_whisper()
        return (await eavesdrop(uuid, true));
      }));
      await this.action('answer');
      await this.sleep(200);
      agent = new this.cfg.queuer.Agent(key);
      call = (await agent.get_onhook_call());
      if (call != null) {
        uuid = (await call.get_id());
        await agent_is_bleg();
        await eavesdrop(uuid, true);
        return;
      }
      call = (await agent.get_offhook_call());
      if (call != null) {
        uuid = (await call.get_id());
        await agent_is_aleg();
        await eavesdrop(uuid, true);
        return;
      }
    };
    // The destination matched.
    ACTION_FIFO_ROUTE = '810';
    ACTION_QUEUER_LOGIN = '811';
    ACTION_QUEUER_LEAVE = '812';
    ACTION_QUEUER_OFFHOOK = '813';
    ACTION_QUEUER_LOGIN_SCRIPT = '814';
    ACTION_FIFO_VOICEMAIL = '817';
    ACTION_QUEUER_LOGOUT = '819';
    ACTION_CONF_ROUTE = '82';
    ACTION_MENU_ROUTE = '83';
    ACTION_INTERCEPT = '84';
    ACTION_MONITOR = '87';
    ACTION_EAVESDROP = '88';
    ACTION_MSG_RECORD = '8011';
    ACTION_MSG_ACTIVATE = '8012';
    ACTION_MSG_DEACTIVATE = '8013';
    ACTION_MSG_LISTEN = '8014';
    debug('Routing', action, number);
    if ((base = this.session).number_domain_data == null) {
      base.number_domain_data = (await this.cfg.prov.get(`number_domain:${this.session.number_domain}`).catch((error) => {
        debug.csr(`number_domain ${number_domain}: ${error}`);
        return {};
      }));
    }
    // * doc.local_number:allowed_groups (array of string) Contains group prefixes that the given user may eavesdrop/monitor. The convention is to use `:` as a path separator. For example: ['sales','support:modems']. See doc.local_number.groups for the groups assigned to a target.
    is_allowed = function(allowed_groups, target_groups) {
      return target_groups != null ? target_groups.some(function(name) {
        return allowed_groups != null ? allowed_groups.some(function(prefix) {
          return name.substr(0, prefix.length) === prefix;
        }) : void 0;
      }) : void 0;
    };
    get = (name, type) => {
      var item, items;
      items = this.session.number_domain_data[name];
      if (items == null) {
        debug.csr(`Number domain has no ${name}.`);
        return;
      }
      if (!((number != null) && items.hasOwnProperty(number))) {
        debug.dev(`No property ${number} in ${name} of ${this.session.number_domain}`);
        return;
      }
      item = items[number];
      if (item != null) {
        if (item.short_name == null) {
          item.short_name = `${type}-${number}`;
        }
        if (type === 'conf') {
          if (item.full_name == null) {
            item.full_name = `${this.session.number_domain}-${item.short_name}`;
          }
        } else {
          if (item.full_name == null) {
            item.full_name = `${item.short_name}@${this.session.number_domain}`;
          }
        }
      }
      return item;
    };
    route = (name, type) => {
      var item;
      item = get(name, type);
      if (item == null) {
        return false;
      }
      this.session[type] = item;
      this.direction(type);
      return true;
    };
    agent_tags = () => {
      var broadcast, i, j, len, len1, queue, queues, skill, skills, tags;
      tags = [];
      ({skills, queues, broadcast} = this.session.number);
      if (skills != null) {
        for (i = 0, len = skills.length; i < len; i++) {
          skill = skills[i];
          tags.push(`skill:${skill}`);
        }
      }
      if (queues != null) {
        for (j = 0, len1 = queues.length; j < len1; j++) {
          queue = queues[j];
          tags.push(`queue:${queue}`);
        }
      }
      if (broadcast) {
        tags.push('broadcast');
      }
      return tags;
    };
    // This works only for centrex.
    agent = (ref3 = this.session.agent) != null ? ref3 : `${this.source}@${this.session.number_domain}`;
    agent_name = (ref4 = this.session.agent_name) != null ? ref4 : this.source;
    ({allowed_groups} = agent_data = (await this.cfg.prov.get(`number:${agent}`).catch(function() {
      return {};
    })));
    failed = () => {
      debug('Failed');
      this.direction('failed');
      return this.action('hangup'); // keep last
    };
    switch (action) {
      case ACTION_CONF_ROUTE:
        debug('Conf: call');
        if (!route('conferences', 'conf')) {
          return failed();
        }
        break;
      case ACTION_MENU_ROUTE:
        debug('Menu: call');
        if (!route('menus', 'menu')) {
          return failed();
        }
        break;
      case ACTION_FIFO_ROUTE:
        debug('FIFO: call');
        if (!route('fifos', 'fifo')) {
          return failed();
        }
        break;
      case ACTION_INTERCEPT:
        if (number == null) {
          return failed();
        }
        uuid = (await this.local_redis.get(`inbound_call:${number}@${this.session.number_domain}`));
        debug('Intercept', uuid);
        if (uuid == null) {
          return failed();
        }
        await this.set({
          intercept_unbridged_only: true
        });
        await this.action('intercept', uuid);
        this.direction('intercepted'); // Really `intercepting`, but oh well
        break;
      // Eavesdrop: call to listen (no notification, no whisper).
      case ACTION_EAVESDROP:
        debug('Eavesdrop', number, allowed_groups, groups);
        if (number == null) {
          return failed();
        }
        if (!is_allowed(allowed_groups, groups)) {
          return failed();
        }
        debug('Eavesdrop');
        await this.set({
          eavesdrop_indicate_failed: 'silence_stream://125',
          eavesdrop_indicate_new: 'silence_stream://125',
          eavesdrop_indicate_idle: 'silence_stream://125',
          eavesdrop_enable_dtmf: true
        });
        spy(false);
        this.direction('eavesdropping');
        break;
      // Monitor: call to listen (with notification beep), and whisper
      case ACTION_MONITOR:
        debug('Monitor', number, allowed_groups, groups);
        if (number == null) {
          return failed();
        }
        if (!is_allowed(allowed_groups, groups)) {
          return failed();
        }
        debug('Monitor');
        await this.set({
          eavesdrop_indicate_failed: 'tone_stream://%(125,0,300)',
          eavesdrop_indicate_new: 'tone_stream://%(125,0,600);%(125,0,450)',
          eavesdrop_indicate_idle: 'tone_stream://%(125,125,450);%(125,0,450)',
          eavesdrop_enable_dtmf: true
        });
        spy(true);
        this.direction('eavesdropping');
        break;
      case ACTION_QUEUER_LOGIN:
        debug('Queuer: log in');
        fifo = get('fifos', 'fifo');
        await this.action('answer');
        await this.sleep(2000);
        if ((base1 = this.session).timezone == null) {
          base1.timezone = this.session.number.timezone;
        }
        await this.queuer_login(agent, agent_name, fifo, agent_tags(), this.session.number.login_ornaments);
        await this.action('gentones', '%(100,20,300);%(100,20,450);%(100,20,600)');
        await this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_QUEUER_LOGIN_SCRIPT:
        debug('Queuer: log in with number in script');
        await this.action('answer');
        await this.sleep(2000);
        if ((base2 = this.session).timezone == null) {
          base2.timezone = this.session.number.timezone;
        }
        this.destination = number;
        await this.queuer_login(agent, agent_name, null, agent_tags(), this.session.number.login_ornaments);
        await this.action('gentones', '%(100,20,300);%(100,20,450);%(100,20,600)');
        await this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_QUEUER_OFFHOOK:
        debug('Queuer: off-hook agent');
        fifo = get('fifos', 'fifo');
        await this.action('answer');
        await this.sleep(2000);
        await this.set({
          hangup_after_bridge: false,
          park_after_bridge: true
        });
        await this.queuer_offhook(agent, agent_name, this.call, fifo, agent_tags());
        this.direction('queuer-offhook');
        break;
      case ACTION_QUEUER_LEAVE:
        debug('Queuer: leave queue');
        fifo = get('fifos', 'fifo');
        if (fifo == null) {
          return failed();
        }
        await this.action('answer');
        await this.sleep(2000);
        await this.queuer_leave(agent, fifo);
        await this.action('gentones', '%(100,20,600);%(100,20,450);%(100,20,600)');
        await this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_QUEUER_LOGOUT:
        debug('Queuer: log out');
        fifo = get('fifos', 'fifo');
        await this.action('answer');
        await this.sleep(2000);
        await this.queuer_logout(agent, fifo);
        await this.action('gentones', '%(100,20,600);%(100,20,450);%(100,20,300)');
        await this.action('hangup');
        this.direction('completed');
        break;
      case ACTION_FIFO_VOICEMAIL:
        debug('FIFO: voicemail');
        fifo = get('fifos', 'fifo');
        if ((fifo != null ? fifo.user_database : void 0) == null) {
          return failed();
        }
        this.destination = 'inbox';
        this.source = 'user-database';
        this.session.voicemail_user_database = fifo.user_database;
        this.session.voicemail_user_id = fifo.full_name;
        return this.direction('voicemail');
      // Menu messages
      case ACTION_MSG_DEACTIVATE:
        debug('deactivate message');
        await this.action('answer');
        await this.sleep(2000);
        doc = this.session.number_domain_data;
        if (doc.msg == null) {
          doc.msg = {};
        }
        if ((base3 = doc.msg)[number] == null) {
          base3[number] = {};
        }
        doc.msg[number].active = false;
        await this.cfg.master_push(doc);
        await this.action('gentones', '%(200,20,600);%(200,20,450)');
        return this.direction('completed');
      case ACTION_MSG_ACTIVATE:
        debug('activate message');
        await this.action('answer');
        await this.sleep(2000);
        doc = this.session.number_domain_data;
        if (doc.msg == null) {
          doc.msg = {};
        }
        if ((base4 = doc.msg)[number] == null) {
          base4[number] = {};
        }
        doc.msg[number].active = true;
        await this.cfg.master_push(doc);
        await this.action('gentones', '%(200,20,450);%(200,20,600)');
        return this.direction('completed');
      case ACTION_MSG_RECORD:
        debug('record message');
        await this.action('answer');
        await this.sleep(2000);
        doc = this.session.number_domain_data;
        file = `msg-${number}.mp3`;
        uri = this.prompt.uri('master-prov', 'ignore', doc._id, file, doc._rev);
        await this.prompt.record(uri);
        await this.action('hangup');
        return this.direction('completed');
      case ACTION_MSG_LISTEN:
        debug('listen to message');
        await this.action('answer');
        await this.sleep(2000);
        doc = this.session.number_domain_data;
        file = `msg-${number}.mp3`;
        uri = this.prompt.uri('prov', 'ignore', doc._id, file);
        await this.action('playback', uri);
        await this.action('hangup');
        return this.direction('completed');
      default:
        debug('Unknown action', action);
        return failed();
    }
  };

}).call(this);
