// Generated by CoffeeScript 2.3.1
(function() {
  var debug, pkg, translate_source;

  pkg = require('../../../package.json');

  this.name = `${pkg.name}:middleware:client:egress:national-CH`;

  debug = (require('tangible'))(this.name);

  translate_source = function(source) {
    var $;
    switch (false) {
      // From: national number
      case !($ = source.match(/^(0|\+41)([1-9][0-9]{8})$/)):
        return `41${$[2]}`;
      // From: international number (why??)
      case !($ = source.match(/^(00|\+)([2-9][0-9]*)$/)):
        return $[2];
      default:
        debug(`Cannot translate source ${source}`);
        return null;
    }
  };

  this.include = function() {
    var entry, i, len, m, new_asserted, new_source, patterns, ref;
    if (((ref = this.session) != null ? ref.direction : void 0) !== 'egress') {
      return;
    }
    if (this.session.dialplan !== 'national') {
      return;
    }
    if (this.session.country !== 'ch') {
      return;
    }
    debug('source', this.source);
    // Verify that the caller-id follows the proper format
    // ---------------------------------------------------
    new_source = translate_source(this.source);
    if (new_source != null) {
      this.session.ccnq_from_e164 = new_source;
    }
    if (this.session.asserted != null) {
      new_asserted = translate_source(this.session.asserted);
      if (new_asserted != null) {
        this.session.asserted = new_asserted;
      }
    }
    // Verify that the called number follows the proper format
    // -------------------------------------------------------
    patterns = [
      {
        // geographic, non-geographic, mobile, or service
        match: /^(0|\+41)([123456789][0-9]{8})$/,
        now: function($) {
          return `41${$[2]}`;
        }
      },
      {
        // special services
        match: /^(1[0-9]{2,5})$/,
        now: function($) {
          return `41_${$[1]}`;
        }
      },
      {
        // international call
        match: /^(00|\+)([0-9]*)$/,
        now: function($) {
          return $[2];
        }
      }
    ];
    for (i = 0, len = patterns.length; i < len; i++) {
      entry = patterns[i];
      m = this.destination.match(entry.match);
      if (m != null) {
        this.session.ccnq_to_e164 = entry.now(m);
        debug('Found', {
          to_e164: this.session.ccnq_to_e164
        });
        return;
      }
    }
    return debug('None found', {
      destination: this.destination
    });
  };

}).call(this);
