// Generated by CoffeeScript 2.3.1
(function() {
  var FS, Moment, Queuer, RedisInterface, SUBSCRIBE, Solid, TaggedAgent, TaggedCall, UPDATE, compile, debug, domain_of, foot, make_id, monitor, now, pkg, request, sleep,
    hasProp = {}.hasOwnProperty;

  this.name = 'huge-play:middleware:client:queuer';

  ({debug, foot} = (require('tangible'))(this.name));

  pkg = {
    name: 'huge-play'
  };

  Moment = require('moment-timezone');

  ({SUBSCRIBE, UPDATE} = require('red-rings/operations'));

  Solid = require('solid-gun');

  make_id = function() {
    return Solid.time() + Solid.uniqueness();
  };

  Queuer = require('black-metal/queuer');

  request = require('superagent');

  compile = require('flat-ornament/compile');

  sleep = function(timeout) {
    return new Promise(function(resolve) {
      return setTimeout(resolve, timeout);
    });
  };

  domain_of = function(key) {
    return key != null ? key.split('@')[1] : void 0;
  };

  now = function(tz = 'UTC') {
    return Moment().tz(tz).format();
  };

  ({TaggedCall, TaggedAgent} = require('black-metal/tagged'));

  monitor = require('screeching-eggs/monitor');

  FS = require('esl');

  RedisInterface = require('normal-key/interface');

  this.server_pre = function() {
    var HugePlayAgent, HugePlayCall, HugePlayQueuer, HugePlayReference, agent_timeout, api, call_timeout, cfg, client, host, options, p, pools_redis_interface, port, profile, prov, ref, ref1, ref2, ref3, ref4;
    cfg = this.cfg;
    HugePlayReference = this.cfg.Reference;
    ({api, prov, host} = this.cfg);
    profile = (ref = this.cfg.session) != null ? ref.profile : void 0;
    p = (ref1 = this.cfg.profiles) != null ? ref1[profile] : void 0;
    if (p != null) {
      port = (ref2 = p.egress_sip_port) != null ? ref2 : p.sip_port + 10000;
    }
    if (!((cfg.local_redis_client != null) && (prov != null) && (profile != null) && (host != null) && (port != null) && (api != null) && (HugePlayReference != null))) {
      debug.dev('Missing configuration');
      return;
    }
    // How long should we keep the state of a call after the last update?
    call_timeout = 8 * 3600;
    // How long should we keep the state of an agent after the last update?
    agent_timeout = 12 * 3600;
    HugePlayCall = (function() {
      // HugePlayCall
      // ------------
      class HugePlayCall extends TaggedCall {
        async build_notification(data) {
          var k, notification, v;
          notification = {
            report_type: 'queuer',
            host: host,
            now: Date.now(),
            domain: (await this.get_domain().catch(function() {
              return null;
            })),
            key: this.key,
            id: (await this.get_id().catch(function() {
              return null;
            })),
            call_state: (await this.state().catch(function() {
              return null;
            })),
            remote_number: (await this.get_remote_number().catch(function() {
              return null;
            })),
            alert_info: (await this.get_alert_info().catch(function() {
              return null;
            })),
            reference: (await this.get_reference().catch(function() {
              return null;
            })),
            answered: (await (async function() {
              switch ((await this.answered().catch(function() {
                    return null;
                  }))) {
                case 'true':
                case true:
                  return true;
                case 'false':
                case false:
                  return false;
                default:
                  return null;
              }
            }).call(this)),
            presenting: (await this.count().catch(function() {
              return null;
            })),
            tags: (await this.tags().catch(function() {
              return [];
            }))
          };
          for (k in data) {
            if (!hasProp.call(data, k)) continue;
            v = data[k];
            if (!(v != null)) {
              continue;
            }
            switch (k) {
              case 'agent':
              case 'call':
              case 'agent_call':
              case 'remote_call':
                if (typeof v !== 'string') {
                  v = v.key;
                }
            }
            if (notification[k] == null) {
              notification[k] = v;
            }
          }
          return notification;
        }

        async notify(data) {
          var notification;
          debug('call.notify', data);
          notification = (await this.build_notification(data));
          if (notification.domain != null) {
            cfg.rr.notify(`number_domain:${notification.domain}`, `call:${notification.id}`, notification);
          }
          debug('call.notify: send', notification);
          return notification;
        }

      };

      HugePlayCall.prototype.interface = new RedisInterface(cfg.local_redis_client, call_timeout);

      HugePlayCall.prototype.__api = api;

      HugePlayCall.prototype.profile = `${pkg.name}-${profile}-egress`;

      HugePlayCall.prototype.Reference = HugePlayReference;

      return HugePlayCall;

    }).call(this);
    HugePlayAgent = (function() {
      // HugePlayAgent
      // -------------
      class HugePlayAgent extends TaggedAgent {
        async notify(data) {
          var agent_name, event, notification, offhook, old_state, reason, state;
          debug('agent.notify', this.key, data);
          ({old_state, state, event, reason} = data);
          notification = {
            report_type: 'queuer',
            host: host,
            now: Date.now(),
            state: state,
            old_state: old_state,
            event: event,
            reason: reason,
            agent: this.key,
            number: this.number,
            number_domain: this.domain,
            missed: (await this.get_missed().catch(function() {
              return 0;
            })),
            count: (await this.count().catch(function() {
              return 0;
            }))
          };
          notification.tags = (await this.tags().catch(function() {
            return [];
          }));
          agent_name = (await (this.get('name')).catch(function() {
            return null;
          }));
          if (agent_name != null) {
            notification.agent_name = agent_name;
          }
          offhook = (await this.get_offhook_call().catch(function() {
            return null;
          }));
          if (offhook) {
            notification.offhook = true;
          } else {
            notification.offhook = false;
          }
          // Module `black-metal` 8.3.0 will report the call object as `data.call` (and this is currently the only parameter that might be provided).

          // If `data.call` is present we notify using the call's process; if it isn't we notify directly.
          // This avoids sending two messages for the same event (one with incomplete data, the other with complete data).
          if (data.call != null) {
            notification = (await data.call.notify(notification));
          }
          cfg.rr.notify(`agent:${notification.agent}`, `agent:${notification.agent}`, notification);
          debug('agent.notify: done', this.key, notification);
        }

        async create_egress_call(body) {
          var _id, account, call, call_data, endpoint, options, queuer_webhook, reference, tags, timezone;
          debug('create_egress_call', this.domain, body);
          if (this.number_domain_data == null) {
            this.number_domain_data = (await prov.get(`number_domain:${this.domain}`).catch(function(error) {
              return null;
            }));
          }
          if (this.number_domain_data == null) {
            debug('create_egress_call: missing number-domain', this.domain);
            return;
          }
          ({account, queuer_webhook, timezone} = this.number_domain_data);
          if (timezone == null) {
            timezone = null;
          }
          await this.set('timezone', timezone);
          if (account == null) {
            debug('create_egress_call: no account', this.domain);
            return null;
          }
          if (body == null) {
            if (queuer_webhook == null) {
              debug('create_egress_call: no queuer_webhook', this.domain);
              return null;
            }
            tags = (await this.tags());
            options = {key: this.key, number: this.number, domain: this.domain, tags};
            debug('create_egress_call: send request', options);
            ({body} = (await request.post(queuer_webhook).send(options)));
          }
          if (body.tags == null) {
            body.tags = [];
          }
          if (!((body.destination != null) && (body.tags != null) && (body.tags.length != null))) {
            debug('create_egress_call: incomplete response', this.domain, body);
            return null;
          }
          body.tags.push('queuer');
          debug('create_egress_call: creating call', this.domain, body);
          body.tags.push('egress');
          // See `in_domain` in black-metal/tagged.
          body.tags.push(`number_domain:${this.domain}`);
          endpoint = this.key;
          reference = new HugePlayReference();
          _id = reference.id;
          // FIXME This is highly inefficient, we should be able to create the structure at once.
          await reference.set_endpoint(endpoint);
          await reference.set_account(account);
          await reference.set_number_domain(this.domain);
          await reference.set_number(endpoint); // Centrex-only
          await reference.set_destination(body.destination);
          await reference.set_source(this.number);
          await reference.set_domain(`${host}:${port}`);
          // await reference.set_tags body.tags # set_tags = clear_tags() + add_tags()
          await reference.set_block_dtmf(true);
          // This is a "fake" call-data entry, to record the data we used to trigger the call for call-reporting purposes.
          call_data = {
            uuid: 'create-egress-call',
            session: `${_id}-create-egress-call`,
            reference: _id,
            start_time: now(timezone),
            source: this.number,
            destination: body.destination,
            timezone: timezone,
            timestamp: now(timezone),
            host: host,
            type: 'call',
            event: 'create-egress-call'
          };
          // Notice that for the new call we explicitely do _not_ `set_id` since this is how `originate_external` recognizes that the call needs to be set up.
          call = new HugePlayCall(make_id());
          await call.set_domain(this.domain);
          await call.set_started_at();
          await call.set_reference(_id);
          await call.set_remote_number(body.destination);
          await call.set_tags(body.tags);
          await call.set('timezone', timezone);
          // async
          this.notify(call_data);
          debug('create_egress_call: complete');
          return call;
        }

      };

      HugePlayAgent.prototype.interface = new RedisInterface(cfg.local_redis_client, agent_timeout);

      return HugePlayAgent;

    }).call(this);
    // Queuer
    // ------

    // The queuer's Redis is used for call pools and the agents pool.
    // Since we're bound to a server for domains it's OK to use the local Redis.
    pools_redis_interface = new RedisInterface(cfg.local_redis_client, agent_timeout);
    HugePlayQueuer = class HugePlayQueuer extends Queuer(pools_redis_interface, {
        Agent: HugePlayAgent,
        Call: HugePlayCall
      }) {
      async notify(key, id, data) {
        var k, notification, ref3, v;
        notification = {
          report_type: 'queuer',
          host: host,
          now: Date.now()
        };
        for (k in data) {
          if (!hasProp.call(data, k)) continue;
          v = data[k];
          if ((ref3 = typeof v) === 'number' || ref3 === 'string' || ref3 === 'boolean') {
            notification[k] = v;
          }
        }
        if (data.call != null) {
          notification = (await data.call.notify(notification));
        }
        cfg.rr.notify(key, id, notification);
      }

    };
    this.cfg.queuer = new HugePlayQueuer(this.cfg);
    options = {
      host: (ref3 = this.cfg.socket_host) != null ? ref3 : '127.0.0.1',
      port: (ref4 = this.cfg.socket_port) != null ? ref4 : 5722
    };
    client = FS.createClient(options);
    monitor(client, this.cfg.queuer.Call);
    // RedRings
    // --------

    // RedRings for agents:
    cfg.rr.receive('agent:*').forEach(async function(msg) {
      var $, agent, broadcast, i, is_remote, j, key, len, len1, queue, queues, ref5, ref6, skill, skills, state, tags, timezone;
      switch (false) {
        case msg.op !== SUBSCRIBE:
          // get agent state
          if (!($ = (ref5 = msg.key) != null ? ref5.match(/^agent:(\S+)$/) : void 0)) {
            return;
          }
          key = $[1];
          is_remote = (await cfg.is_remote(domain_of(key)));
          if (is_remote !== false) {
            return;
          }
          debug('queuer:get-agent-state', key);
          agent = new HugePlayAgent(key);
          state = (await agent.state().catch(function() {
            return null;
          }));
          await agent.notify({state});
          break;
        case msg.op !== UPDATE:
          // log agent in or out; use redring.create() for login, redring.delete() for logout
          if (!($ = (ref6 = msg.id) != null ? ref6.match(/^agent:(\S+)$/) : void 0)) {
            return;
          }
          key = $[1];
          is_remote = (await cfg.is_remote(domain_of(key)));
          if (is_remote !== false) {
            return;
          }
          if (msg.deleted) {
            debug('queue:log-agent-out', key);
            agent = new HugePlayAgent(key);
            await agent.clear_tags();
            await agent.transition('logout');
          } else {
            debug('queue:log-agent-in', key);
            tags = [];
            ({skills, queues, broadcast, timezone} = (await cfg.prov.get(`number:${key}`)));
            if (skills != null) {
              for (i = 0, len = skills.length; i < len; i++) {
                skill = skills[i];
                tags.push(`skill:${skill}`);
              }
            }
            if (queues != null) {
              for (j = 0, len1 = queues.length; j < len1; j++) {
                queue = queues[j];
                tags.push(`queue:${queue}`);
              }
            }
            if (broadcast) {
              tags.push('broadcast');
            }
            agent = new HugePlayAgent(key);
            await agent.add_tags(tags);
            /* FIXME FIXME
            if ornaments?
              ctx = {agent,timezone}
              fun = compile ornaments
              await fun.call ctx if fun?
            */
            await agent.accept_onhook();
          }
      }
    });
    // Note: RedRings agent notifications are handled above (in the HugePlayCall and HugePlayAgent classes).

    // RedRings for pools:
    cfg.rr.receive('pool:*').filter(function({op}) {
      return op === SUBSCRIBE;
    }).forEach(async function(msg) {
      var $, calls, domain, is_remote, name, notification, pool, ref5, result;
      if (!($ = (ref5 = msg.key) != null ? ref5.match(/^pool:(\S+):(ingress|egress)$/) : void 0)) {
        return;
      }
      domain = $[1];
      name = $[2];
      is_remote = (await cfg.is_remote(domain));
      if (is_remote !== false) {
        return;
      }
      pool = (function() {
        switch (name) {
          case 'ingress':
            return cfg.queuer.ingress_pool(domain);
          case 'egress':
            return cfg.queuer.egress_pool(domain);
        }
      })();
      calls = (await pool.calls());
      result = (await Promise.all(calls.map(function(call) {
        return call.build_notification({});
      })));
      notification = {
        host: host,
        now: Date.now(),
        calls: result
      };
      cfg.rr.notify(msg.key, `number_domain:${domain}`, notification);
    });
  };

  // Middleware
  // ==========
  this.include = async function() {
    var Agent, Call, local_server, uuid;
    if ((await this.reference.get_block_dtmf())) {
      await this.action('block_dtmf');
    }
    if (this.cfg.queuer == null) {
      return;
    }
    ({Agent, Call} = this.cfg.queuer);
    if (!((Agent != null) && (Call != null))) {
      return;
    }
    // Queuer Call object
    // ------------------
    ({uuid} = this.call);
    this.queuer_call = async function(id) {
      var domain, queuer_call;
      domain = this.session.number_domain;
      if (id == null) {
        id = uuid;
      }
      debug('queuer_call', id, domain);
      queuer_call = new Call(id);
      await queuer_call.set_domain(domain);
      await queuer_call.set_started_at();
      await queuer_call.set_id(id);
      await queuer_call.set_reference(this.session.reference);
      return queuer_call;
    };
    // Agent state monitoring
    // ----------------------
    local_server = [this.session.local_server, this.session.client_server].join('/');
    // On-hook agent
    // -------------
    this.queuer_login = async function(source, name, fifo, tags = [], ornaments) {
      var agent, fun;
      debug('queuer_login', source);
      agent = new Agent(source);
      await agent.set('name', name);
      await agent.add_tags(tags);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.add_tag(`queue:${fifo.full_name}`);
      }
      // * doc.local_number.login_commands: (optional) array of ornaments, applied when a call-center agent logs into the system.
      if (ornaments != null) {
        this.agent = agent;
        fun = compile(ornaments, this.ornaments_commands);
        if (fun != null) {
          await fun.call(this);
        }
      }
      await agent.accept_onhook();
      await this.report({
        state: 'queuer-login',
        source,
        fifo,
        tags
      });
      return agent;
    };
    this.queuer_leave = async function(source, fifo) {
      var agent;
      debug('queuer_leave', source);
      agent = new Agent(source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.del_tag(`queue:${fifo.full_name}`);
      }
      await this.report({
        state: 'queuer-leave',
        source,
        fifo
      });
      return agent;
    };
    this.queuer_logout = async function(source, fifo) {
      var agent;
      debug('queuer_logout', source);
      agent = new Agent(source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.del_tag(`queue:${fifo.full_name}`);
      }
      await agent.clear_tags();
      await agent.transition('logout');
      await this.report({
        state: 'queuer-logout',
        source,
        fifo
      });
      return agent;
    };
    // Off-hook agent
    // --------------
    return this.queuer_offhook = async function(source, name, {uuid}, fifo, tags = []) {
      var agent, call;
      debug('queuer_offhook', source, uuid, fifo);
      agent = new Agent(source);
      await agent.set('name', name);
      agent.clear_tags();
      await agent.add_tags(tags);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await agent.add_tag(`queue:${fifo.full_name}`);
      }
      call = (await agent.accept_offhook(uuid));
      if (call == null) {
        return;
      }
      await this.report({
        state: 'queuer-offhook',
        source,
        fifo,
        tags
      });
      return agent;
    };
  };

}).call(this);
