// Generated by CoffeeScript 2.3.1
(function() {
  var GET, RedisClient, Reference, SET, Solid, reference_id;

  Solid = require('solid-gun');

  RedisClient = require('normal-key/client');

  reference_id = function() {
    return Solid.time() + Solid.uniqueness();
  };

  // Just like RedisClient, this needs a `redis` value, which should be an instance of RedisInterface (`normal-key/interface`).
  SET = function(name) {
    return function(value) {
      return this.set(name, value);
    };
  };

  GET = function(name) {
    return function() {
      return this.get(name);
    };
  };

  Reference = (function() {
    class Reference extends RedisClient {
      constructor(id) {
        if (id == null) {
          id = reference_id();
        }
        super('xref', id);
        this.id = id;
      }

      set_call_options(options) {
        return this.set('call_options', JSON.stringify(options));
      }

      async get_call_options() {
        var options;
        options = (await this.get('call_options'));
        if (options != null) {
          return JSON.parse(options);
        } else {
          return {};
        }
      }

    };

    Reference.prototype.set_endpoint = SET('endpoint');

    Reference.prototype.set_destination = SET('destination');

    Reference.prototype.set_source = SET('source');

    Reference.prototype.set_domain = SET('domain');

    Reference.prototype.set_dev_logger = SET('dev_logger');

    Reference.prototype.set_account = SET('account');

    Reference.prototype.set_block_dtmf = SET('block_dtmf');

    Reference.prototype.set_number = SET('number');

    Reference.prototype.set_number_domain = SET('number_domain');

    Reference.prototype.get_endpoint = GET('endpoint');

    Reference.prototype.get_destination = GET('destination');

    Reference.prototype.get_source = GET('source');

    Reference.prototype.get_domain = GET('domain');

    Reference.prototype.get_dev_logger = GET('dev_logger');

    Reference.prototype.get_account = GET('account');

    Reference.prototype.get_block_dtmf = GET('block_dtmf');

    Reference.prototype.get_number = GET('number');

    Reference.prototype.get_number_domain = GET('number_domain');

    return Reference;

  }).call(this);

  module.exports = Reference;

}).call(this);
